Index: trunk/source/Lib/TLibRenderer/TRenSingleModel.cpp
===================================================================
--- trunk/source/Lib/TLibRenderer/TRenSingleModel.cpp	(revision 1387)
+++ trunk/source/Lib/TLibRenderer/TRenSingleModel.cpp	(revision 1396)
@@ -56,5 +56,5 @@
 
   m_pcOutputSamples      = NULL; 
-  m_pcOutputSamplesRow   = NULL;   
+  m_pcOutputSamplesRow   = NULL; 
   m_iOutputSamplesStride = -1; 
 
@@ -106,6 +106,6 @@
   if ( m_pcOutputSamples    ) delete[] m_pcOutputSamples   ;
 
-  if ( m_piInvZLUTLeft  ) delete[] m_piInvZLUTLeft ;
-  if ( m_piInvZLUTRight ) delete[] m_piInvZLUTRight;
+  if ( m_piInvZLUTLeft      ) delete[] m_piInvZLUTLeft ;
+  if ( m_piInvZLUTRight     ) delete[] m_piInvZLUTRight;
 
   if ( m_aapiRefVideoPel[0] ) delete[] ( m_aapiRefVideoPel[0] - ( m_aiRefVideoStrides[0] * m_iPad + m_iPad ) );
@@ -116,10 +116,11 @@
 template <BlenMod iBM, Bool bBitInc> Void
 #if H_3D_VSO_EARLY_SKIP
-TRenSingleModelC<iBM,bBitInc>::create( Int iMode, Int iWidth, Int iHeight, Int iShiftPrec, Int*** aaaiSubPelShiftTable, Int iHoleMargin, Bool bUseOrgRef, Int iBlendMode, Bool bEarlySkip )
-#else
-TRenSingleModelC<iBM,bBitInc>::create( Int iMode, Int iWidth, Int iHeight, Int iShiftPrec, Int*** aaaiSubPelShiftTable, Int iHoleMargin, Bool bUseOrgRef, Int iBlendMode )
-#endif
-
-{
+TRenSingleModelC<iBM,bBitInc>::create( Int iMode, Int iWidth, Int iHeight, Int iShiftPrec, Int*** aaaiSubPelShiftTable, Int iHoleMargin, Bool bUseOrgRef, Int iBlendMode, Bool bLimOutput, Bool bEarlySkip )
+#else
+TRenSingleModelC<iBM,bBitInc>::create( Int iMode, Int iWidth, Int iHeight, Int iShiftPrec, Int*** aaaiSubPelShiftTable, Int iHoleMargin, Bool bUseOrgRef, Int iBlendMode, Bool bLimOutput )
+#endif
+
+{
+  m_bLimOutput = bLimOutput; 
 #if H_3D_VSO_EARLY_SKIP
   m_pbHorSkip     = new Bool [MAX_CU_SIZE];
@@ -127,6 +128,5 @@
 #endif
 
-  AOF( iBlendMode == iBM ); 
-
+  AOF( ( iBlendMode == iBM ) || ( iBM == BLEND_NONE ) ); 
   m_iMode = iMode;
 
@@ -171,5 +171,6 @@
   m_pcInputSamples[1]     = new RenModelInPels[m_iInputSamplesStride*m_iHeight];
 
-  m_pcOutputSamples       = new RenModelOutPels[m_iOutputSamplesStride*m_iHeight];  
+  m_pcOutputSamples       = new RenModelOutPels   [m_iOutputSamplesStride*m_iHeight];
+  m_pcLimOutputSamples    = m_bLimOutput ? new RenModelLimOutPels[m_iOutputSamplesStride*m_iHeight] : NULL;
 }
 
@@ -244,8 +245,54 @@
 }
 
-template <BlenMod iBM, Bool bBitInc> Void
-TRenSingleModelC<iBM,bBitInc>::setup( TComPicYuv* pcOrgVideo, Int** ppiShiftLutLeft, Int** ppiBaseShiftLutLeft, Int** ppiShiftLutRight,  Int** ppiBaseShiftLutRight,  Int iDistToLeft, Bool bKeepReference )
-{
+
+#if !RM_FIX_SETUP
+template <BlenMod iBM, Bool bBitInc> Void
+  TRenSingleModelC<iBM,bBitInc>::setupInitialState( Int curViewPosInModel )
+{
+  xRenderAll( );
+
+  if ( m_bLimOutput )
+  {
+    AOT( curViewPosInModel == VIEWPOS_INVALID )
+    xSetLimOutStruct( (curViewPosInModel == VIEWPOS_RIGHT)  ? VIEWPOS_LEFT : VIEWPOS_RIGHT );
+  }
+}
+#endif
+
+#if RM_FIX_SETUP
+template <BlenMod iBM, Bool bBitInc> Void
+  TRenSingleModelC<iBM,bBitInc>::setupRefView      ( TComPicYuv* pcOrgVideo )
+{
+  m_pcPicYuvRef = pcOrgVideo;
+  // Use provided ref view reference
+  
+  TRenFilter<REN_BIT_DEPTH>::copy(             pcOrgVideo->getAddr( COMPONENT_Y  ) +  m_iHorOffset       * pcOrgVideo->getStride( COMPONENT_Y  ), pcOrgVideo->getStride( COMPONENT_Y  ), m_iWidth,      m_iUsedHeight,      m_aapiRefVideoPel[0], m_aiRefVideoStrides[0]);
+  switch ( pcOrgVideo->getChromaFormat() )
+  {
+  case CHROMA_420:
+    TRenFilter<REN_BIT_DEPTH>::sampleCUpHorUp(0, pcOrgVideo->getAddr( COMPONENT_Cb ) + (m_iHorOffset >> 1) * pcOrgVideo->getStride( COMPONENT_Cb ), pcOrgVideo->getStride( COMPONENT_Cb ), m_iWidth >> 1, m_iUsedHeight >> 1, m_aapiRefVideoPel[1], m_aiRefVideoStrides[1]);
+    TRenFilter<REN_BIT_DEPTH>::sampleCUpHorUp(0, pcOrgVideo->getAddr( COMPONENT_Cr ) + (m_iHorOffset >> 1) * pcOrgVideo->getStride( COMPONENT_Cr ), pcOrgVideo->getStride( COMPONENT_Cr ), m_iWidth >> 1, m_iUsedHeight >> 1, m_aapiRefVideoPel[2], m_aiRefVideoStrides[2]);
+    break;
+  case CHROMA_444:
+    TRenFilter<REN_BIT_DEPTH>::copy(             pcOrgVideo->getAddr( COMPONENT_Cb  ) +  m_iHorOffset       * pcOrgVideo->getStride( COMPONENT_Cb  ), pcOrgVideo->getStride( COMPONENT_Cb  ), m_iWidth,      m_iUsedHeight,      m_aapiRefVideoPel[1], m_aiRefVideoStrides[1]);
+    TRenFilter<REN_BIT_DEPTH>::copy(             pcOrgVideo->getAddr( COMPONENT_Cr  ) +  m_iHorOffset       * pcOrgVideo->getStride( COMPONENT_Cr  ), pcOrgVideo->getStride( COMPONENT_Cr  ), m_iWidth,      m_iUsedHeight,      m_aapiRefVideoPel[2], m_aiRefVideoStrides[2]);
+    break;
+  default:
+    break; 
+  }
+  xSetStructRefView();
+}
+
+
+template <BlenMod iBM, Bool bBitInc> Void
+  TRenSingleModelC<iBM,bBitInc>::setupLut( Int** ppiShiftLutLeft, Int** ppiBaseShiftLutLeft, Int** ppiShiftLutRight,  Int** ppiBaseShiftLutRight,  Int iDistToLeft )
+#else
+template <BlenMod iBM, Bool bBitInc> Void
+  TRenSingleModelC<iBM,bBitInc>::setupLutAndRef( TComPicYuv* pcOrgVideo, Int** ppiShiftLutLeft, Int** ppiBaseShiftLutLeft, Int** ppiShiftLutRight,  Int** ppiBaseShiftLutRight,  Int iDistToLeft, Bool bRenderRef )
+#endif
+{
+#if !RM_FIX_SETUP
   AOT( !m_bUseOrgRef && pcOrgVideo );
+#endif
   AOT( (ppiShiftLutLeft  == NULL) && (m_iMode == 0 || m_iMode == 2) );
   AOT( (ppiShiftLutRight == NULL) && (m_iMode == 1 || m_iMode == 2) );
@@ -254,10 +301,17 @@
   m_appiShiftLut[1] = ppiShiftLutRight;
 
+
+  if ( m_iMode == 2 )
+  {
+    TRenFilter<REN_BIT_DEPTH>::setupZLUT( true, 30, iDistToLeft, ppiBaseShiftLutLeft, ppiBaseShiftLutRight, m_iBlendZThres, m_iBlendDistWeight, m_piInvZLUTLeft, m_piInvZLUTRight );
+  }
+
+#if !RM_FIX_SETUP
   // Copy Reference
   m_pcPicYuvRef = pcOrgVideo;
 
-  if ( pcOrgVideo && !bKeepReference )
-  {
-    assert( pcOrgVideo->getChromaFormat() != CHROMA_420 );     
+  if ( pcOrgVideo )
+  {
+    assert( pcOrgVideo->getChromaFormat() == CHROMA_420 );     
 
     TRenFilter<REN_BIT_DEPTH>::copy(             pcOrgVideo->getAddr( COMPONENT_Y  ) +  m_iHorOffset       * pcOrgVideo->getStride( COMPONENT_Y  ), pcOrgVideo->getStride( COMPONENT_Y  ), m_iWidth,      m_iUsedHeight,      m_aapiRefVideoPel[0], m_aiRefVideoStrides[0]);
@@ -266,7 +320,28 @@
     xSetStructRefView();
   }
-
+  else
+  {
+    if ( bRenderRef )
+    {    
+      xRenderAll( ); 
+      xSetStructSynthViewAsRefView();
+    }
+  }
+#endif
+}
+
+template <BlenMod iBM, Bool bBitInc> Void
+#if RM_FIX_SETUP
+TRenSingleModelC<iBM,bBitInc>::renderAll( )
+#else
+TRenSingleModelC<iBM,bBitInc>::xRenderAll( )
+#endif
+{
   // Initial Rendering
+#if RM_FIX_SETUP
+  resetStructError();
+#else
   xResetStructError();
+#endif
   xInitSampleStructs();
   switch ( m_iMode )
@@ -274,24 +349,23 @@
   case 0:   
 #if H_3D_VSO_EARLY_SKIP
-    xRenderL<true>( 0, 0, m_iWidth, m_iUsedHeight, m_aiBaseDepthStrides[0], m_apiBaseDepthPel[0],false );
-#else
-    xRenderL<true>( 0, 0, m_iWidth, m_iUsedHeight, m_aiBaseDepthStrides[0], m_apiBaseDepthPel[0] );
+    xRender<true, SET_FULL>( 0, 0, m_iWidth, m_iUsedHeight, m_aiBaseDepthStrides[0], m_apiBaseDepthPel[0],false );
+#else
+    xRender<true, SET_FULL>( 0, 0, m_iWidth, m_iUsedHeight, m_aiBaseDepthStrides[0], m_apiBaseDepthPel[0] );
 #endif   
     break;
   case 1:    
 #if H_3D_VSO_EARLY_SKIP
-    xRenderR<true>( 0, 0, m_iWidth, m_iUsedHeight, m_aiBaseDepthStrides[1], m_apiBaseDepthPel[1],false);
-#else
-    xRenderR<true>( 0, 0, m_iWidth, m_iUsedHeight, m_aiBaseDepthStrides[1], m_apiBaseDepthPel[1] );
+    xRender<false, SET_FULL>( 0, 0, m_iWidth, m_iUsedHeight, m_aiBaseDepthStrides[1], m_apiBaseDepthPel[1],false);
+#else
+    xRender<false, SET_FULL>( 0, 0, m_iWidth, m_iUsedHeight, m_aiBaseDepthStrides[1], m_apiBaseDepthPel[1] );
 #endif
     break;
   case 2:
-    TRenFilter<REN_BIT_DEPTH>::setupZLUT( true, 30, iDistToLeft, ppiBaseShiftLutLeft, ppiBaseShiftLutRight, m_iBlendZThres, m_iBlendDistWeight, m_piInvZLUTLeft, m_piInvZLUTRight );
-#if H_3D_VSO_EARLY_SKIP
-    xRenderL<true>( 0, 0, m_iWidth, m_iUsedHeight, m_aiBaseDepthStrides[0], m_apiBaseDepthPel[0],false);
-    xRenderR<true>( 0, 0, m_iWidth, m_iUsedHeight, m_aiBaseDepthStrides[1], m_apiBaseDepthPel[1],false);
+#if H_3D_VSO_EARLY_SKIP
+    xRender<true , SET_FULL>( 0, 0, m_iWidth, m_iUsedHeight, m_aiBaseDepthStrides[0], m_apiBaseDepthPel[0],false);
+    xRender<false, SET_FULL>( 0, 0, m_iWidth, m_iUsedHeight, m_aiBaseDepthStrides[1], m_apiBaseDepthPel[1],false);
 #else      
-    xRenderL<true>( 0, 0, m_iWidth, m_iUsedHeight, m_aiBaseDepthStrides[0], m_apiBaseDepthPel[0] );
-    xRenderR<true>( 0, 0, m_iWidth, m_iUsedHeight, m_aiBaseDepthStrides[1], m_apiBaseDepthPel[1] );
+    xRender<true,  SET_FULL>( 0, 0, m_iWidth, m_iUsedHeight, m_aiBaseDepthStrides[0], m_apiBaseDepthPel[0] );
+    xRender<false, SET_FULL>( 0, 0, m_iWidth, m_iUsedHeight, m_aiBaseDepthStrides[1], m_apiBaseDepthPel[1] );
 #endif
     break;
@@ -299,11 +373,4 @@
     AOT(true);
   }
-
-  // Get Rendered View as Reference
-  if ( !pcOrgVideo && !bKeepReference )
-  {
-    xResetStructError();
-    xSetStructSynthViewAsRefView();
-  }
 }
 
@@ -317,4 +384,12 @@
   switch ( iViewNum )
   {
+
+  case -1:  
+    rpiSrcY = &RenModelOutPels::iYRef;
+#if H_3D_VSO_COLOR_PLANES  
+    rpiSrcU = &RenModelOutPels::iURef;
+    rpiSrcV = &RenModelOutPels::iVRef;
+#endif
+    break;
   case 0:
     rpiSrcY = &RenModelOutPels::iYLeft;
@@ -349,4 +424,11 @@
 }
 
+template <BlenMod iBM, Bool bBitInc> Void
+  TRenSingleModelC<iBM,bBitInc>::xGetSampleStrFilledPtrs( Int iViewNum, Int RenModelOutPels::*& rpiSrcFilled )
+{
+  AOT(iViewNum != 0 && iViewNum != 1);  
+  rpiSrcFilled = (iViewNum == 1) ? &RenModelOutPels::iFilledRight : &RenModelOutPels::iFilledLeft; 
+}
+
 
 template <BlenMod iBM, Bool bBitInc> Void
@@ -383,5 +465,9 @@
 
 template <BlenMod iBM, Bool bBitInc> Void
+#if RM_FIX_SETUP
+TRenSingleModelC<iBM,bBitInc>::resetStructError( )
+#else
 TRenSingleModelC<iBM,bBitInc>::xResetStructError( )
+#endif
 {
   RenModelOutPels* pcCurOutSampleRow = m_pcOutputSamples;
@@ -398,5 +484,62 @@
 
 template <BlenMod iBM, Bool bBitInc> Void
+#if RM_FIX_SETUP
+  TRenSingleModelC<iBM,bBitInc>::setLimOutStruct(Int iSourceViewPos )
+#else
+  TRenSingleModelC<iBM,bBitInc>::xSetLimOutStruct(Int iSourceViewPos )
+#endif
+{  
+  RM_AOF( m_bLimOutput ); 
+  RM_AOT( iSourceViewPos < 0 || iSourceViewPos > 1);
+
+  RenModelOutPels*    pcCurOutSampleRow    = m_pcOutputSamples;
+  RenModelLimOutPels* pcCurLimOutSampleRow = m_pcLimOutputSamples;
+
+  Int RenModelOutPels::* piFilled = NULL;
+  xGetSampleStrFilledPtrs( iSourceViewPos, piFilled );
+  
+  Pel RenModelOutPels::* piDepth  = NULL;
+  xGetSampleStrDepthPtrs ( iSourceViewPos, piDepth  );
+
+  Pel RenModelOutPels::* piSrcY = NULL;
+  
+#if H_3D_VSO_COLOR_PLANES  
+  Pel RenModelOutPels::* piSrcU = NULL;  
+  Pel RenModelOutPels::* piSrcV = NULL;
+  xGetSampleStrTextPtrs  ( iSourceViewPos, piSrcY, piSrcU, piSrcV );
+#else
+  xGetSampleStrTextPtrs  ( iSourceViewPos, piSrcY );
+#endif
+  
+  for ( Int iPosY = 0; iPosY < m_iUsedHeight; iPosY++ )
+  {
+    for ( Int iPosX = 0; iPosX < m_iWidth; iPosX++ )
+    {      
+      pcCurLimOutSampleRow[iPosX].iYOther      = pcCurOutSampleRow[iPosX].*piSrcY;
+      pcCurLimOutSampleRow[iPosX].iYRef        = pcCurOutSampleRow[iPosX].iYRef;
+
+#if H_3D_VSO_COLOR_PLANES      
+      pcCurLimOutSampleRow[iPosX].iUOther      = pcCurOutSampleRow[iPosX].*piSrcU;
+      pcCurLimOutSampleRow[iPosX].iURef        = pcCurOutSampleRow[iPosX].iURef;
+
+      pcCurLimOutSampleRow[iPosX].iVOther      = pcCurOutSampleRow[iPosX].*piSrcV;      
+      pcCurLimOutSampleRow[iPosX].iVRef        = pcCurOutSampleRow[iPosX].iVRef;
+#endif
+      pcCurLimOutSampleRow[iPosX].iDOther      = pcCurOutSampleRow[iPosX].*piDepth;      
+      pcCurLimOutSampleRow[iPosX].iFilledOther = pcCurOutSampleRow[iPosX].*piFilled;      
+      pcCurLimOutSampleRow[iPosX].iError       = pcCurOutSampleRow[iPosX].iError;      
+
+    } 
+    pcCurOutSampleRow    += m_iOutputSamplesStride; 
+    pcCurLimOutSampleRow += m_iOutputSamplesStride; 
+  }
+}
+
+template <BlenMod iBM, Bool bBitInc> Void
+#if RM_FIX_SETUP
+TRenSingleModelC<iBM,bBitInc>::setStructSynthViewAsRefView( )
+#else
 TRenSingleModelC<iBM,bBitInc>::xSetStructSynthViewAsRefView( )
+#endif
 {
   AOT( m_iMode < 0 || m_iMode > 2);
@@ -447,4 +590,5 @@
       pcOutSampleRow[iPosX].iDRight       = 0;
       pcOutSampleRow[iPosX].iDBlended     = 0;      
+      pcOutSampleRow[iPosX].iError        = 0; 
                                      
       // Y Planes                    
@@ -463,7 +607,7 @@
       pcOutSampleRow[iPosX].iVBlended     = 1 << (REN_BIT_DEPTH  - 1);
 #endif
-      //// Input Samples
-      pcLeftInSampleRow [iPosX].bOccluded = false;
-      pcRightInSampleRow[iPosX].bOccluded = false;
+  //// Input Samples
+      pcLeftInSampleRow [iPosX].aiOccludedPos = MAX_INT;
+      pcRightInSampleRow[iPosX].aiOccludedPos = MIN_INT;
     }
 
@@ -491,22 +635,22 @@
   case 0:
 #if H_3D_VSO_EARLY_SKIP
-    bEarlySkip = m_bEarlySkip ? xDetectEarlySkipL(iStartPosX,   iStartPosY,   iWidth,   iHeight,   iStride, piNewData, piOrgData, iOrgStride) : false;
+    bEarlySkip = m_bEarlySkip ? xDetectEarlySkip<true>(iStartPosX,   iStartPosY,   iWidth,   iHeight,   iStride, piNewData, piOrgData, iOrgStride) : false;
     if( !bEarlySkip )
     {
-      iSSE = xRenderL<false>( iStartPosX,   iStartPosY,   iWidth,   iHeight,   iStride, piNewData,true );
+      iSSE = xRender<true, GET_SIMP>( iStartPosX,   iStartPosY,   iWidth,   iHeight,   iStride, piNewData,true );
     }    
 #else
-    iSSE = xRenderL<false>( iStartPosX,   iStartPosY,   iWidth,   iHeight,   iStride, piNewData );
+    iSSE = xRender<true, GET_SIMP>( iStartPosX,   iStartPosY,   iWidth,   iHeight,   iStride, piNewData );
 #endif
     break;
   case 1:
 #if H_3D_VSO_EARLY_SKIP
-    bEarlySkip = m_bEarlySkip ? xDetectEarlySkipR(iStartPosX,   iStartPosY,   iWidth,   iHeight,   iStride, piNewData, piOrgData, iOrgStride) : false;
+    bEarlySkip = m_bEarlySkip ? xDetectEarlySkip<false>(iStartPosX,   iStartPosY,   iWidth,   iHeight,   iStride, piNewData, piOrgData, iOrgStride) : false;
     if( !bEarlySkip )
     {
-      iSSE = xRenderR<false>( iStartPosX,   iStartPosY,   iWidth,   iHeight,   iStride, piNewData,true );
+      iSSE = xRender<false, GET_SIMP>( iStartPosX,   iStartPosY,   iWidth,   iHeight,   iStride, piNewData,true );
     }    
 #else
-    iSSE = xRenderR<false>( iStartPosX,   iStartPosY,   iWidth,   iHeight,   iStride, piNewData );
+    iSSE = xRender<false, GET_SIMP>( iStartPosX,   iStartPosY,   iWidth,   iHeight,   iStride, piNewData );
 #endif
     break;
@@ -525,5 +669,5 @@
 #endif
 {
-#ifdef  H_3D_VSO_EARLY_SKIP
+#if  H_3D_VSO_EARLY_SKIP
   Bool bEarlySkip;
 #endif
@@ -532,22 +676,22 @@
   case 0:
 #if H_3D_VSO_EARLY_SKIP
-    bEarlySkip = m_bEarlySkip ? xDetectEarlySkipL(iStartPosX,   iStartPosY,   iWidth,   iHeight,   iStride, piNewData, piOrgData,iOrgStride) : false;
+    bEarlySkip = m_bEarlySkip ? xDetectEarlySkip<true>(iStartPosX,   iStartPosY,   iWidth,   iHeight,   iStride, piNewData, piOrgData,iOrgStride) : false;
     if( !bEarlySkip )
     {
-      xRenderL<true>( iStartPosX,   iStartPosY,   iWidth,   iHeight,   iStride, piNewData,true );
+      xRender<true, SET_SIMP>( iStartPosX,   iStartPosY,   iWidth,   iHeight,   iStride, piNewData,true );
     }    
 #else
-    xRenderL<true>( iStartPosX,   iStartPosY,   iWidth,   iHeight,   iStride, piNewData );
+    xRender<true, SET_SIMP>( iStartPosX,   iStartPosY,   iWidth,   iHeight,   iStride, piNewData );
 #endif     
     break;
   case 1:
 #if H_3D_VSO_EARLY_SKIP
-    bEarlySkip = m_bEarlySkip ? xDetectEarlySkipR(iStartPosX,   iStartPosY,   iWidth,   iHeight,   iStride, piNewData, piOrgData,iOrgStride) : false;
+    bEarlySkip = m_bEarlySkip ? xDetectEarlySkip<false>(iStartPosX,   iStartPosY,   iWidth,   iHeight,   iStride, piNewData, piOrgData,iOrgStride) : false;
     if( !bEarlySkip )
     {
-      xRenderR<true>( iStartPosX,   iStartPosY,   iWidth,   iHeight,   iStride, piNewData,true ); 
+      xRender<false, SET_SIMP>( iStartPosX,   iStartPosY,   iWidth,   iHeight,   iStride, piNewData,true ); 
     }    
 #else
-    xRenderR<true>( iStartPosX,   iStartPosY,   iWidth,   iHeight,   iStride, piNewData );
+    xRender<false, SET_SIMP>( iStartPosX,   iStartPosY,   iWidth,   iHeight,   iStride, piNewData );
 #endif     
     break;
@@ -585,6 +729,6 @@
   Pel RenModelOutPels::* piY;
   xGetSampleStrTextPtrs(iViewPos, piY); 
-  xCopyFromSampleStruct( m_pcOutputSamples, m_iOutputSamplesStride, piY, pcPicYuv->getLumaAddr() + m_iHorOffset * pcPicYuv->getStride(), pcPicYuv->getStride(), m_iWidth, m_iUsedHeight );
-  pcPicYuv->setChromaTo( 1 << (g_bitDepthC - 1) );   
+  xCopyFromSampleStruct( m_pcOutputSamples, m_iOutputSamplesStride, piY, pcPicYuv->getAddr(COMPONENT_Y) + m_iHorOffset * pcPicYuv->getStride(COMPONENT_Y), pcPicYuv->getStride(COMPONENT_Y), m_iWidth, m_iUsedHeight );
+  pcPicYuv->setChromaTo( 1 << (REN_BIT_DEPTH - 1) );   
 #endif  
 }
@@ -633,6 +777,6 @@
   xCopy2PicYuv( apiData, aiStrides, pcPicYuv );
 #else
-  xCopyFromSampleStruct( m_pcOutputSamples, m_iOutputSamplesStride, &RenModelOutPels::iYRef, pcPicYuv->getLumaAddr() *  pcPicYuv->getStride() + m_iHorOffset, pcPicYuv->getStride(), m_iWidth, m_iUsedHeight );
-  pcPicYuv->setChromaTo( 1 << ( g_bitDepthC - 1 ) );   
+  xCopyFromSampleStruct( m_pcOutputSamples, m_iOutputSamplesStride, &RenModelOutPels::iYRef, pcPicYuv->getAddr(COMPONENT_Y), pcPicYuv->getStride(COMPONENT_Y), m_iWidth, m_iUsedHeight );
+  pcPicYuv->setChromaTo( 1 << ( REN_BIT_DEPTH - 1 ) );   
 #endif  
 }
@@ -653,26 +797,40 @@
 
 
-template <BlenMod iBM, Bool bBitInc> __inline Void
+template <BlenMod iBM, Bool bBitInc> template<SetMod bSM> __inline Void
 TRenSingleModelC<iBM,bBitInc>::xSetViewRow( Int iPosY )
 {
   m_pcInputSamplesRow[0] = m_pcInputSamples[0] + m_iInputSamplesStride  * iPosY;
   m_pcInputSamplesRow[1] = m_pcInputSamples[1] + m_iInputSamplesStride  * iPosY;
-  m_pcOutputSamplesRow   = m_pcOutputSamples   + m_iOutputSamplesStride * iPosY;  
-
-}
-
-template <BlenMod iBM, Bool bBitInc> __inline Void
+  if (bSM == SET_FULL || bSM == GET_FULL )
+  {  
+    m_pcOutputSamplesRow   = m_pcOutputSamples   + m_iOutputSamplesStride * iPosY;  
+  }
+  else
+  {
+    m_pcLimOutputSamplesRow   = m_pcLimOutputSamples  + m_iOutputSamplesStride * iPosY;  
+  }
+}
+
+template <BlenMod iBM, Bool bBitInc> template<SetMod bSM> __inline Void
 TRenSingleModelC<iBM,bBitInc>::xIncViewRow( )
 {
   m_pcInputSamplesRow[0] += m_iInputSamplesStride ;
   m_pcInputSamplesRow[1] += m_iInputSamplesStride ;
-  m_pcOutputSamplesRow   += m_iOutputSamplesStride;  
-}
-#if H_3D_VSO_EARLY_SKIP
-template <BlenMod iBM, Bool bBitInc> template<Bool bSet> __inline RMDist 
-TRenSingleModelC<iBM,bBitInc>::xRenderL( Int iStartPosX, Int iStartPosY, Int iWidth, Int iHeight, Int iStride, const Pel* piNewData, Bool bFast)
-#else
-template <BlenMod iBM, Bool bBitInc> template<Bool bSet> __inline RMDist 
-TRenSingleModelC<iBM,bBitInc>::xRenderL( Int iStartPosX, Int iStartPosY, Int iWidth, Int iHeight, Int iStride, const Pel* piNewData)
+  
+  if (bSM == SET_FULL || bSM == GET_FULL )
+  {  
+    m_pcOutputSamplesRow   += m_iOutputSamplesStride;
+  }
+  else
+  {
+    m_pcLimOutputSamplesRow   += m_iOutputSamplesStride;
+  }
+}
+#if H_3D_VSO_EARLY_SKIP
+template <BlenMod iBM, Bool bBitInc> template<SetMod bSM> __inline RMDist 
+TRenSingleModelC<iBM,bBitInc>::xGetSSE( Int iStartPosX, Int iStartPosY, Int iWidth, Int iHeight, Int iStride, const Pel* piNewData, Bool bFast)
+#else
+template <BlenMod iBM, Bool bBitInc> template<SetMod bSM> __inline RMDist 
+TRenSingleModelC<iBM,bBitInc>::xGetSSE( Int iStartPosX, Int iStartPosY, Int iWidth, Int iHeight, Int iStride, const Pel* piNewData)
 #endif
 {
@@ -680,6 +838,44 @@
   const Int iOtherViewPos = 1;
 
-  m_iCurViewPos   = iCurViewPos  ; 
-  m_iOtherViewPos = iOtherViewPos;
+  m_piNewDepthData   = piNewData;  
+  m_iNewDataWidth    = iWidth;     
+  m_iStartChangePosX = iStartPosX; 
+
+  if ((iWidth == 0) || (iHeight == 0))
+    return 0;
+
+  xSetViewRow<bSM>      ( iStartPosY);
+
+  // Init Start
+  RMDist iError = 0;     
+  Int iStartChangePos = m_iStartChangePosX; 
+  Int iEndChangePos   = m_iStartChangePosX + iWidth - 1;
+
+  for (Int iPosY = iStartPosY; iPosY < iStartPosY + iHeight; iPosY++ )
+  {    
+    Int iPosXinNewData        = iWidth - 1;                       
+    for ( Int iCurPosX = iEndChangePos; iCurPosX >= iStartChangePos; iCurPosX-- )
+    {
+      Int iCurDepth   = m_piNewDepthData[iPosXinNewData];
+      Int iOldDepth   = m_pcInputSamplesRow[iCurViewPos][iCurPosX].iD; 
+      Int iDiff = (iCurDepth - iOldDepth);
+      iError += iDiff * iDiff;
+      iPosXinNewData--; 
+    }
+    xIncViewRow<bSM>();
+    m_piNewDepthData += iStride;
+  }
+  return iError;
+}
+
+#if H_3D_VSO_EARLY_SKIP
+template <BlenMod iBM, Bool bBitInc> template<Bool bL, SetMod bSM> __inline RMDist 
+TRenSingleModelC<iBM,bBitInc>::xRender( Int iStartPosX, Int iStartPosY, Int iWidth, Int iHeight, Int iStride, const Pel* piNewData, Bool bFast)
+#else
+template <BlenMod iBM, Bool bBitInc> template<Bool bL, SetMod bSM> __inline RMDist 
+TRenSingleModelC<iBM,bBitInc>::xRender( Int iStartPosX, Int iStartPosY, Int iWidth, Int iHeight, Int iStride, const Pel* piNewData)
+#endif
+{
+  const Int iCurViewPos   = bL ? 0 : 1;
 
   m_piNewDepthData   = piNewData;
@@ -688,9 +884,11 @@
 
   if ((iWidth == 0) || (iHeight == 0))
+  {
     return 0;
+  }
 
   // Get Data
   m_ppiCurLUT      = m_appiShiftLut   [iCurViewPos];
-  xSetViewRow      ( iStartPosY);
+  xSetViewRow<bSM>( iStartPosY);
 
   // Init Start
@@ -698,5 +896,5 @@
   Int   iStartChangePos;
 
-  iStartChangePos = m_iStartChangePosX;
+  iStartChangePos = m_iStartChangePosX + ( bL ? 0  : (iWidth - 1));
 
   for (Int iPosY = iStartPosY; iPosY < iStartPosY + iHeight; iPosY++ )
@@ -707,5 +905,5 @@
       if ( m_pbHorSkip[iPosY-iStartPosY] )
       {
-        xIncViewRow();
+        xIncViewRow<bSM>();
         m_piNewDepthData += iStride;
         continue;
@@ -716,70 +914,75 @@
 
     Int iLastSPos;
-    Int iEndChangePos         = m_iStartChangePosX + iWidth - 1;
-    Int iPosXinNewData        = iWidth - 1;
-    Int iMinChangedSPos       = m_iSampledWidth;
-
-    if ( iEndChangePos == ( m_iWidth -1 )) // Special processing for rightmost depth sample
+    Int iEndChangePos         = m_iStartChangePosX + ( bL ? (iWidth - 1) : 0 ) ;
+
+    Int iEndChangePosInSubPel = iEndChangePos << m_iShiftPrec;
+    Int iPosXinNewData        = bL ? iWidth - 1 : 0; 
+    Int iMinChangedSPos       = bL ? m_iSampledWidth : -1;
+    if ( iEndChangePos == xWidthMinus1<bL>() )
     {
       m_iCurDepth           = m_piNewDepthData[iPosXinNewData];
-      Int iCurSPos          = xShiftNewData(iEndChangePos, iPosXinNewData);
-      m_iLastOccludedSPos   = iCurSPos + 1;
-      m_iLastOccludedSPosFP = xRangeLeftL( m_iLastOccludedSPos );
-      xExtrapolateMarginL<bSet>  ( iCurSPos, iEndChangePos, iError );
-
-      iMinChangedSPos       = std::min( iMinChangedSPos, (iEndChangePos << m_iShiftPrec) - m_ppiCurLUT[0][ RenModRemoveBitInc( std::max(m_pcInputSamplesRow[iCurViewPos][iEndChangePos].iD, m_piNewDepthData[iPosXinNewData] )) ]);
-      iLastSPos             = iCurSPos;
-      m_iLastDepth          = m_iCurDepth;
-
-      if ( bSet )
+      Int iCurSPos          = xShiftDept(iEndChangePosInSubPel, m_iCurDepth );
+
+      m_curRangeStart       = xRangeLeft<bL>( iCurSPos );
+      xExtrapolateMargin<bL, bSM>  ( iCurSPos, iEndChangePos, iError );
+
+      Int iOldDepth          = m_pcInputSamplesRow[iCurViewPos][iEndChangePos].iD;
+      iMinChangedSPos        = xMin<Int, bL>( ( iOldDepth <= m_iCurDepth ) ? iCurSPos : xShiftDept(iEndChangePosInSubPel, iOldDepth ), iMinChangedSPos);
+      iLastSPos           = iCurSPos;
+      m_lastRangeStart    = m_curRangeStart;
+      m_iLastDepth        = m_iCurDepth;
+      m_iLastOccludedSPos = iLastSPos;
+
+      if ( bSM == SET_FULL || bSM == SET_SIMP )
       {
         m_pcInputSamplesRow[iCurViewPos][iEndChangePos].iD = m_piNewDepthData[iPosXinNewData];
       }
 
-      iPosXinNewData--;
-      iEndChangePos--;
+      xDec<Int, bL>(iPosXinNewData);
+      xDec<Int, bL>(iEndChangePos);
     }
     else
     {
-      iLastSPos    = xShift(iEndChangePos+1);
-      m_iLastDepth = m_pcInputSamplesRow [iCurViewPos][iEndChangePos+1].iD;
-      xInitRenderPartL( iEndChangePos, iLastSPos );
+      m_iLastDepth = m_pcInputSamplesRow [iCurViewPos][xPlus<Int,bL>(iEndChangePos,1)].iD;
+      iLastSPos    = xShiftDept(xPlus<Int,bL>(iEndChangePosInSubPel, ( 1 << m_iShiftPrec ) ), m_iLastDepth );
+      xInitRenderPart<bL>( iEndChangePos, iLastSPos );
     }
 
     //// RENDER NEW DATA
     Int iCurPosX;
-    for ( iCurPosX = iEndChangePos; iCurPosX >= iStartChangePos; iCurPosX-- )
-    {
-      // Get minimal changed sample position
-
-      iMinChangedSPos = std::min( iMinChangedSPos, (iCurPosX << m_iShiftPrec) - m_ppiCurLUT[0][ RenModRemoveBitInc( std::max(m_pcInputSamplesRow[iCurViewPos][iCurPosX].iD, m_piNewDepthData[iPosXinNewData] )) ]);
-      Int iCurSPos    = xShiftNewData(iCurPosX,iPosXinNewData);
-      m_iCurDepth     = m_piNewDepthData[iPosXinNewData];
-      xRenderRangeL<bSet>(iCurSPos, iLastSPos, iCurPosX, iError );
+    for ( iCurPosX = iEndChangePos; xGeQ<Int,bL>(iCurPosX,iStartChangePos); xDec<Int,bL>(iCurPosX))
+    {
+      Int iCurPosXInSubPel = iCurPosX << m_iShiftPrec;
+      m_iCurDepth     = m_piNewDepthData[iPosXinNewData]        ;
+      Int iCurSPos    = xShiftDept(iCurPosXInSubPel,m_iCurDepth);  
+
+      Int iOldDepth   = m_pcInputSamplesRow[iCurViewPos][iCurPosX].iD;
+      iMinChangedSPos = xMin<Int,bL>( ( iOldDepth <= m_iCurDepth ) ? iCurSPos : xShiftDept(iCurPosXInSubPel, iOldDepth ), iMinChangedSPos);
+
+      xRenderRange<bL,bSM>(iCurSPos, iLastSPos, iCurPosX, iError );
       iLastSPos       = iCurSPos;
       m_iLastDepth    = m_iCurDepth;
 
-      if ( bSet )
+      if ( bSM == SET_FULL || bSM == SET_SIMP )
       {
         m_pcInputSamplesRow[iCurViewPos][iCurPosX].iD = m_piNewDepthData[iPosXinNewData];
       }
-
-      iPosXinNewData--;
+      xDec<Int,bL>(iPosXinNewData);
     }
 
     //// RE-RENDER DATA LEFT TO NEW DATA
-    while ( iCurPosX >= 0 )
-    {
-      Int iCurSPos = xShift(iCurPosX);
-
+
+    while ( xGeQ<Int,bL>(iCurPosX, xZero<bL>() ) )
+    {
+      Int iCurPosXInSubPel = iCurPosX << m_iShiftPrec;
       m_iCurDepth  = m_pcInputSamplesRow[iCurViewPos][iCurPosX].iD;
-      xRenderRangeL<bSet>( iCurSPos, iLastSPos, iCurPosX, iError );
-
-      if ( iCurSPos < iMinChangedSPos )
+      Int iCurSPos = xShiftDept(iCurPosXInSubPel,m_iCurDepth);      
+      xRenderRange<bL,bSM>( iCurSPos, iLastSPos, iCurPosX, iError );
+      if ( xLess<Int,bL>(iCurSPos,iMinChangedSPos) )
       {
-          break;
+        break;
       }
 
-      iCurPosX--;
+      xDec<Int,bL>(iCurPosX);
       iLastSPos    = iCurSPos;
       m_iLastDepth = m_iCurDepth;
@@ -787,5 +990,7 @@
 
 
-    xIncViewRow();
+
+
+    xIncViewRow<bSM>();
     m_piNewDepthData += iStride;
   }
